﻿// -----------------------------------------------------------------------
// <copyright file="MySimpleStructDisposable.cs" company="none">
// Copyright (c) 2012 M. Alberti, xanatos(at)live.it
// Distributed under the MIT/X11 software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.
// </copyright>
// -----------------------------------------------------------------------

namespace FluentSerializer.Sample
{
    using System;
    using System.Linq.Expressions;
    using FluentSerializer;
    using FluentStatement;

    /// <summary>
    /// 
    /// </summary>
    [FluentSerializable(typeof(MySimpleStructDisposable.Serializer))]
    public class MySimpleStructDisposable : IDisposable
    {
        /// <summary>
        /// 
        /// </summary>
        public int Int1 { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool Disposed { get; protected set; }

        #region IDisposable Members

        /// <summary>
        ///
        /// </summary>
        public void Dispose()
        {
            this.Disposed = true;
        }

        #endregion

        /// <summary>
        /// 
        /// </summary>
        public class Serializer : ISerializer<MySimpleStructDisposable, EmptyParameters>
        {
            #region ISerializer<MySimpleDisposableStruct,EmptyParameters> Members

            /// <summary>
            /// 
            /// </summary>
            /// <returns></returns>
            public Expression<Serializer<MySimpleStructDisposable, EmptyParameters>> GetSerializer()
            {
                return (op, obj, par) => Statement.Start(fl => fl
                    .Serialize(obj.Int1)

                    .Empty());
            }

            #endregion
        }
    }
}
